//+------------------------------------------------------------------+
//|                                                          apz.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2

extern int     drawBars          = 1000;
extern int     period            = 5;
extern double  deviation         = 2.0;

double a[],b[],d[],e[],a1[];
// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>
int init(){
   IndicatorBuffers(5);
   SetIndexBuffer(0,a);
   SetIndexBuffer(1,b);   
   SetIndexStyle(0,DRAW_LINE,EMPTY,0,LimeGreen);
   SetIndexStyle(1,DRAW_LINE,EMPTY,0,OrangeRed); 
   SetIndexBuffer(2,d);
   SetIndexBuffer(3,e);
   SetIndexBuffer(4,a1);
}

// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>
int deinit(){
   //objectsDelete(WindowExpertName());
}

// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>
int start(){
   int bars = 0, i = 0, i2 = 0;	
   double close[];
   double APZRange = 0;
      
   ArrayResize(close,0); ArrayResize(close,ArraySize(Close)); 
   for (int k = 0; k < ArraySize(close); k++) close[k] = Close[ArraySize(close)- 1 - k];
   
	bars = IndicatorCounted();
   if (bars < 0) return(-1);
   i = Bars - bars - 1;
   
	if (i > drawBars) i = drawBars;
	i2 = i;	
	
	while (i > 0){	
	  //a[i] = 0; b[i] = 0; c[i] = 0;
	  e[i] = High[i] - Low[i];
	  a1[i] = iMAOnArray(close,0,period,0,MODE_EMA,i);
	  i--;
	}
	i = i2;
	while (i > 0){	 
	  d[i] = iMAOnArray(e,0,period,0,MODE_EMA,i);//APZRange
	  i--;
	}
	
	//*
	i = i2;
	while (i > 0){	 	  
	  APZRange = iMAOnArray(d,0,period,0,MODE_EMA,i);//APZRange 2
	  a[i] = iMAOnArray(a1,0,period,0,MODE_EMA,i) + APZRange * deviation;
	  b[i] = iMAOnArray(a1,0,period,0,MODE_EMA,i) - APZRange * deviation;
	  i--;
	}
	//*/
	
}

// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>
// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>
// --->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>--->>